!     excdem.F90      calculates excess demand vector, and expenditure and labor demand matrix

subroutine excdemand(NN, H, wpop, w, Dist, theta, T, XT, zp)
	use MSIMSL
	implicit none
	
	integer(4), intent(in) :: NN
	real(8), intent(in) :: theta
	real(8), dimension(NN, NN), intent(in) :: Dist
	real(8), dimension(NN), intent(in) :: H, wpop, w, T

	real(8), dimension(NN), intent(out) :: zp
	real(8), dimension(NN, NN) :: XT

	real(8), dimension(NN):: z
	real(8), dimension(NN, NN) ::  LT

	integer(4):: imp, exp
!	real(8), dimension(NN, NN):: XX
	real(8), dimension(NN):: num

	! ==============================================
	! per capita expenditure matrix

	do imp = 1, NN
		do exp = 1, NN
			num(exp) = T(exp)*(Dist(imp, exp)*w(exp))**(-theta) 
		end do
		LT(imp, :) = (num/sum(num))*(w(imp)*wpop(imp))
	end do

	! =============================================
	! total expenditures and labor demand matrices
		
	do exp = 1, NN
		do imp = 1, NN
			XT(imp, exp) = LT(imp, exp)*H(imp)
		end do
	end do

	! ============================================
	! excess demand vectors (total and as a percentage of population)

	z = sum(XT, DIM = 1) - w*wpop*H
	zp = z/(w*wpop*H)

end subroutine excdemand
