
subroutine findrealw(NN, wpop, lambdain, win, alpha, sigmaa, sigmab, PA0, PB0, UT, realw)
	
	use MSIMSL
	implicit none

	real(8), parameter :: toll = 5e-8
	integer(4), parameter :: maxi = 3000

	integer(4), intent(in) :: NN
	real(8), intent(in) :: sigmab, sigmaa, alpha
	real(8), dimension(NN), intent(in) :: wpop, PA0, PB0, UT, lambdain, win
	real(8), dimension(NN), intent(out) :: realw
	
	real(8), dimension(NN):: lambda
	integer(4):: imp, exp, counti
	real(8):: spsi, ctrlam, ua, ub, uab, error, errold, lamold, ctrpa, ctrpb, rd

!	real(8), dimension(NN):: ew, ximp, num, numb, xhimp, qshare, qnum, qshare2
!	real(8) :: error, errold, spsi, rd, ctrlam, lamold, hshare, nhlam, auxa, auxb
	
	lambda = lambdain
	realw = win

	do imp = 1, NN
		spsi = 0.5
		counti = 1
		ctrlam = lambda(imp)
		ctrpa = PA0(imp)
		ctrpb = PB0(imp)

		! calculate utility for a given lambda
		! ================================================================
		! sector A
		ua = (alpha**sigmaa)*(sigmaa/(sigmaa - 1))*(ctrlam**(1-sigmaa))*(ctrpa**(1-sigmaa))
		! sector B
		ub = ((1 - alpha)**sigmab)*(sigmab/(sigmab - 1))*(ctrlam**(1-sigmab))*(ctrpb**(1-sigmab))
		! total
		uab = ua + ub
		! ==================================================================

		error = UT(imp) - uab
		lamold = ctrlam
		errold = error
!		print *, imp, error

		implamb: do
			! stop controls
			!==========================================================
			if (abs(error) < toll) then
				lambda(imp) = ctrlam
				exit implamb
			else if ( counti >= maxi) then
				print *, "lambdas did not converge in real wage", imp
				stop
				exit implamb
			end if

			! ============================================================
			! new guess
			! ============================================================
			ctrlam = lamold*(1. - spsi*error)
			if (ctrlam < 0) then
				spsi = spsi*(1.e-1)
				ctrlam = 0.9*lamold
			end if

			! ============================================================
			! calculate utility for a given lambda
			! ================================================================
			! sector A
			ua = (alpha**sigmaa)*(sigmaa/(sigmaa - 1))*(ctrlam**(1-sigmaa))*(ctrpa**(1-sigmaa))
			! sector B
			ub = ((1 - alpha)**sigmab)*(sigmab/(sigmab - 1))*(ctrlam**(1-sigmab))*(ctrpb**(1-sigmab))
			! total
			uab = ua + ub
			! ==================================================================
			
			error = UT(imp) - uab
!			print *, counti, ctrlam, error, spsi
!			if (mod(counti,100)==0) print *, counti, ctrlam, error

			call random_number(rd)
			if (rd > (49./50.)) then
				spsi = max(min(10., spsi), 0.01)
			else if (abs(error + errold) < abs(error) + abs(errold)) then
			! decrease sensitivity if error changed sign
				spsi = spsi*(0.9 + rd/8.)
			! increase otherwise
			else 
				spsi = spsi*(1.2 + rd/8.)
			end if		

			if (abs(error) > abs(errold)) then
				error = errold
				ctrlam = lamold
			else
				lamold = ctrlam
				errold = error
			end if
			
			counti = counti + 1

		end do implamb
	
	end	do
	realw = (PA0**(1 - sigmaa))*(lambda**(-sigmaa))*(alpha**(sigmaa)) + (PB0**(1 - sigmab))*(lambda**(-sigmab))*((1-alpha)**(sigmab))
	realw = realw/wpop

end subroutine findrealw