!     excdem.F90      calculates excess demand vector, and expenditure and labor demand matrix

subroutine excdemand(NN, H, wpop, w, Dist, T, XT, zp, theta, thetab, xshareA)

	use MSIMSL
	implicit none
	
	integer(4), intent(in) :: NN
	real(8), intent(in) :: theta, thetab
	real(8), dimension(NN, NN), intent(in) :: Dist
	real(8), dimension(NN), intent(in) :: H, wpop, w, T, xshareA

	real(8), dimension(NN), intent(out) :: zp
	real(8), dimension(NN, NN), intent(out) :: XT

	real(8), dimension(NN) :: z, auxa, auxb, numeratora, numeratorb
	integer(4):: imp, exp, j
	real(8), dimension(NN):: num

	! ==============================================
	! expenditure shares
	auxa = T*(w**(-theta))
	auxb = T*(w**(-thetab))
	do imp = 1, NN
		numeratora = auxa*(Dist(imp,:)**(-theta))
		numeratorb = auxb*(Dist(imp,:)**(-thetab))
		! trade shares = weighted average of type A shares and type B shares
		XT(imp,:) = xsharea(imp)*(numeratora/sum(numeratora)) + (1. - xsharea(imp))*(numeratorb/sum(numeratorb)) 
		! total trade flows = trade shares * importer total income 
		XT(imp,:) = XT(imp,:)*(w(imp)*wpop(imp)*H(imp))
	end do

	! ============================================
	! excess demand vectors (total and as a percentage of population)

	z = sum(XT, DIM = 1) - w*wpop*H
	zp = z/(w*wpop*H)

end subroutine excdemand

