!     parameter_var.F90      estimates the variance-covariance matrix for parameters without clustering,
!							 using the standard NLLS formula

subroutine   parameter_var(n, nobs, Xderivatives, residuals, varparam)

	use MSIMSL
	implicit none
	
	integer(4), intent(in) :: n, nobs
	real(8), dimension(nobs, n), intent(in)	:: Xderivatives
	real(8), dimension(nobs), intent(in) :: residuals
	real(8), dimension(n, n), intent(out) :: varparam

	real(8) :: sigmar
	real(8), dimension(n, n) :: auxm

	! =========================================================
	
	sigmar = sum(residuals**2)/nobs

	call DMXTXF(nobs, n, Xderivatives, nobs, n, auxm, n)

	call DLINRG(n, auxm, n, varparam, n)

	varparam = varparam*sigmar

	end subroutine  parameter_var
