! ============================================================	
! ============================================================	
! READS DATA
! ==========================================================
! ==========================================================

subroutine readata(NN, availability, w, w_highest, w_fourth, w_third, w_second, w_lowest)
				  
	implicit none
	
	integer(4), intent(in) :: NN
	real(8), dimension(NN), intent(out) :: w				! wages 1999 (normalized to US = 1)
	integer(4), dimension(NN), intent(out) :: availability
	real(8), dimension(NN), intent(out) :: w_highest, w_fourth, w_third, w_second, w_lowest

	! internal variables
	real(8), dimension(NN) :: share
	integer, dimension(NN) :: test
	integer(4) :: j
	

! ============================================================
! WAGES (NORMALIZED BY US WAGES)


	open(2, file = 'percgdp.dat', STATUS ='OLD')
	do j = 1, NN
		read(2,*), w(j)
	end do
	close(2)
	w = w/w(1)


! ============================================================
! availability of data on income distribution


	open(2, file = 'dataavailability_ineq.dat', STATUS ='OLD')
	do j = 1, NN
		read(2,*), availability(j)
	end do
	close(2)
	

! ============================================================
! WAGES FOR EACH INCOME GROUP (QUINTILES)

!wages in the highest quintile
share = 0.2
open(2, file = 'qshare_highest_ineq.dat', STATUS ='OLD')
	do j=1,NN
		if (availability(j) == 1) read(2,*), share(j)			! income share
	end do
close(2)
w_highest = (w*share)/.2

!wages in the fourth quintile
share = 0.2
open(2, file = 'qshare_fourth_ineq.dat', STATUS ='OLD')
	do j=1,NN
		if (availability(j) == 1)  read(2,*), share(j)			! income share
	end do
close(2)
w_fourth = (w*share)/.2

!wages in the third quintile
share = 0.2
open(2, file = 'qshare_third_ineq.dat', STATUS ='OLD')
	do j=1,NN
		if (availability(j) == 1) read(2,*), share(j)			! income share
	end do
close(2)
w_third = (w*share)/.2

!wages in the second quintile
share = 0.2
open(2, file = 'qshare_second_ineq.dat', STATUS ='OLD')
	do j=1,NN
		if (availability(j) == 1) 	read(2,*), share(j)			! income share
	end do
close(2)
w_second = (w*share)/.2

!wages in the lowest quintile
w_lowest = (w - (w_highest*.2 + w_fourth*.2 + w_third*.2 + w_second*.2))/.2


! tests if wages are in the right order
test = 0
where ((availability == 1) .and. (w_highest < w_fourth)) test = 1
where ((availability == 1) .and. (w_fourth < w_third)) test = 1
where ((availability == 1) .and. (w_third < w_second)) test = 1
where ((availability == 1) .and. (w_second < w_lowest)) test = 1
where ((availability == 1) .and. (w_lowest < 0)) test = 1

print *, "test must be equal to zero"
print *, "test = ", sum(test)
print *, " ------------------------------------------ "
print *, " "


where (availability == 0) w_highest = w
where (availability == 0) w_fourth = w
where (availability == 0) w_third = w
where (availability == 0) w_second = w
where (availability == 0) w_lowest = w


! activate lines below to eliminate inequalitites
!w_highest = w
!w_fourth = w
!w_third = w
!w_second = w
!w_lowest = w


end subroutine readata
